package eu.future.earth.gwt.client;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.logical.shared.HasValueChangeHandlers;
import com.google.gwt.event.logical.shared.ValueChangeEvent;
import com.google.gwt.event.logical.shared.ValueChangeHandler;
import com.google.gwt.event.shared.HandlerRegistration;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.PushButton;
import com.google.gwt.user.client.ui.SimplePanel;
import com.google.gwt.user.client.ui.Widget;

import eu.future.earth.gwt.client.date.FtrGwtResources;
import eu.future.earth.gwt.client.date.picker.DatePickerDialog;
import eu.future.earth.gwt.client.date.picker.DateSelectEvent;
import eu.future.earth.gwt.client.date.picker.DateSelectListener;
import eu.future.earth.gwt.client.date.picker.HasDateSelectHandlers;
import eu.future.earth.gwt.client.date.picker.NoneContraintAndEntryRenderer;

public class DateButtonWithPicker extends SimplePanel implements ClickHandler, DateSelectListener, HasValueChangeHandlers<Date> {

	private PushButton dateButton = new PushButton(new Image(FtrGwtResources.IMAGES.cal()));

	private DatePickerDialog datePicker = null;

	private NoneContraintAndEntryRenderer renderer = new NoneContraintAndEntryRenderer();

	private List<Widget> toAdd = new ArrayList<Widget>();

	public void addWidgetToPicker(Widget newWidget) {
		toAdd.add(newWidget);
	};

	public DateButtonWithPicker() {
		super();
		setWidget(dateButton);
		dateButton.addClickHandler(this);
	}

	private boolean state = true;

	public void setEditable(boolean newState) {
		state = newState;
		if (state) {
			dateButton.setVisible(true);
		} else {
			dateButton.setVisible(false);
		}
	}

	public void setButtonEnabled(boolean newState) {
		dateButton.setEnabled(newState);
	}

	private Date theDate = null;

	public void setDate(Date newValue) {
		theDate = newValue;
	}

	public Date getValue() {
		return theDate;
	}

	public void onClick(ClickEvent widget) {
		if (datePicker == null) {
			datePicker = new DatePickerDialog(renderer);
			datePicker.addDateSelectEventHandler(this);
			for (Widget add : toAdd) {
				datePicker.addWidgetToPicker(add);
			}
		}

		if (theDate == null) {
			theDate = new Date();
		}
		datePicker.setSelectedDate(theDate);
		datePicker.show(this);
	}

	public HandlerRegistration addValueChangeHandler(ValueChangeHandler<Date> handler) {
		return addHandler(handler, ValueChangeEvent.getType());
	}

	public void handleDateSelectEvent(DateSelectEvent newEvent) {
		if (newEvent.getSource() == datePicker) {
			
		} else {
//			set
		}
		
		theDate = newEvent.getDate();
		ValueChangeEvent.fire(this, newEvent.getDate());
	}

}
