package eu.future.earth.gwt.client.date;

import com.google.gwt.user.client.rpc.AsyncCallback;

import eu.future.earth.gwt.client.date.DateEvent.DateEventActions;

public class AddCallBackHandler<T> implements AsyncCallback<T> {

	private DatePanel<T> view = null;

	private T data = null;

	public AddCallBackHandler(DatePanel<T> view, T theData) {
		super();
		this.view = view;
		data = theData;
	}

	public T getData() {
		return data;
	}

	public DatePanel<T> getView() {
		return view;
	}

	public void sendFailureEvent() {
		view.notifyReady(DateEventActions.ADD_FAILED, data, false);
	}

	public void onFailure(Throwable caught) {
		sendFailureEvent();
	}

	public void onSuccess(T result) {
		view.notifyReady(DateEventActions.ADD_DONE, result, false);
	}

}
