/*
 * Copyright 2007 Future Earth, info@future-earth.eu
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package eu.future.earth.gwt.client.date;

import java.util.Date;
import java.util.List;

import com.google.gwt.event.shared.HandlerRegistration;

import eu.future.earth.gwt.client.date.DateEvent.DateEventActions;

public interface DatePanel<T> {

	void clearData();

	void setDate(Date newDate);

	void setPixelSize(int width, int height);

	Date getFirstDateShow();

	Date getLastDateShow();

	Date getFirstDateLogical();

	Date getLastDateLogical();

	void notifyReady(DateEventActions action, T data, boolean reload);

	Date next();

	Date prev();

	Date nextMore();

	Date prevMore();

	void loadData();

	void addEventData(T newEvent);

	void setEvents(List<? extends T> events);

	void addEventsByList(List<? extends T> events);

	void updateEventData(T newEvent);

	void removeEventData(T newEvent);

	HandlerRegistration addDateEventHandler(DateEventListener<? extends T> handler);

	PanelType getType();

}
