/*
 * Copyright 2007 Future Earth, info@future-earth.eu
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package eu.future.earth.gwt.client.date;

import java.util.Date;

import com.google.gwt.i18n.client.DateTimeFormat;

public interface DateRenderer<T> extends TimeEventRendererVertical<T> {

	boolean supportDayView();
	
	boolean gotoDayViewOnClick();
	
	boolean headerClickable();

	boolean supportMonthView();

	boolean supportListView();

	boolean supportWeekView();

	boolean showWholeDayEventView();

	boolean showDay(int dayCode);

	int getEventTopHeight();
	
	int getWholeEventRowHeigt();

	int getEventBottomHeight();

	int getEventMinimumHeight();

	int getEventCornerSize();

	int getScrollHour();

	boolean isWholeDayEvent(T event);

	int getIntervalHeight();

	int getIntervalsPerHour();

	boolean showIntervalTimes();

	boolean show24HourClock();

	boolean useShowMore();

	void createNewAfterClick(Date currentDate, Date endTime, DateEventListener<? extends T> listener);

	void createNewAfterClick(Date currentDate, DateEventListener<? extends T> listener);

	void editAfterClick(T data, DateEventListener<? extends T> listener);

	EventPanel<? extends T> createPanel(T newData, PanelType viewType);

	String getTitleDisplayText(DatePanel<? extends T> thePanel);

	DateTimeFormat getDayHeaderDateTimeFormatter();

	String getDay(Date theDate);

	String getTime(Date theDate);

	void getEventsForRange(Date start, Date end, DatePanel<T> caller, boolean reloadData);

	AddCallBackHandler<T> createAddHandler(DatePanel<T> view, T theData);
	
	UpdateCallBackHandler<T> createUpdateHandler(DatePanel<T> view, T theData);
	
	RemoveCallBackHandler<T> createRemoveHandler(DatePanel<T> view, T theData);
	
	void addEvent(AddCallBackHandler<T> callback);

	void updateEvent(UpdateCallBackHandler<T> callback);

	void removeEvent(RemoveCallBackHandler<T> callback);

	boolean supportWeekListView();

	int getEndHour();

	int getStartHour();

}
