package eu.future.earth.gwt.client.date.horizontal;

import com.google.gwt.user.client.ui.AbsolutePanel;
import com.google.gwt.user.client.ui.Widget;

public class ExtendedHorizontalAbsolutePanel<T, M> extends AbsolutePanel {

	private BaseHorizontalRowPanel<T, M> parent = null;

	public ExtendedHorizontalAbsolutePanel(BaseHorizontalRowPanel<T, M> newParent) {
		super();
		parent = newParent;
	}

	public void addNormal(Widget w, int left, int top) {
		super.add(w, left, top);
	}

	@SuppressWarnings("unchecked")
	public void add(Widget w, int left, int top) {
		if (parent instanceof HorizontalItemRow<?, ?> && w instanceof HorizontalDayField<?, ?>) {
			final HorizontalItemRow<T, M> real = (HorizontalItemRow<T, M>) parent;
			final HorizontalDayField<T, M> realField = (HorizontalDayField<T, M>) w;
			real.addEvent(realField);
			real.repaint();
		}
		super.add(w, left, top);
	}

	public boolean removeNormal(Widget w) {
		return super.remove(w);
	}

	@SuppressWarnings("unchecked")
	public boolean remove(Widget w) {
		boolean res = super.remove(w);
		if (parent instanceof HorizontalItemRow<?, ?> && w instanceof HorizontalDayField<?, ?>) {
			final HorizontalItemRow<T, M> real = (HorizontalItemRow<T, M>) parent;
			final HorizontalDayField<T, M> realField = (HorizontalDayField<T, M>) w;
			real.removeEvent(realField.getValue());
			real.repaint();
		}
		return res;
	}

}
