package eu.future.earth.gwt.client.date.horizontal;

import com.google.gwt.user.client.rpc.AsyncCallback;

import eu.future.earth.gwt.client.date.DateEvent.DateEventActions;

public class HorizontalAddCallBackHandler<T, M> implements AsyncCallback<T> {

	private HorizontalViewPanelNoDays<T, M> view = null;

	private T data = null;

	public HorizontalAddCallBackHandler(HorizontalViewPanelNoDays<T, M> view, T theData) {
		super();
		this.view = view;
		data = theData;
	}

	public T getData() {
		return data;
	}

	public HorizontalViewPanelNoDays<T, M> getView() {
		return view;
	}

	public void sendFailureEvent() {
		view.notifyReady(DateEventActions.ADD_FAILED, data, true);
	}

	public void onFailure(Throwable caught) {
		sendFailureEvent();
	}

	public void onSuccess(T result) {
		view.notifyReady(DateEventActions.ADD_DONE, data, false);
	}

}
