package eu.future.earth.gwt.client.date.horizontal;

import java.util.Date;

import com.google.gwt.user.client.ui.Widget;

import eu.future.earth.gwt.client.date.DateEventListener;
import eu.future.earth.gwt.client.date.EventPanel;
import eu.future.earth.gwt.client.date.HorizontalDateCalculatorRenderer;
import eu.future.earth.gwt.client.date.UniversalDateRenderer;

public interface HorizontalDateRenderer<T, M> extends UniversalDateRenderer<T>, HorizontalDateCalculatorRenderer {

	int getRowHeight();

	Widget getLabelForMaster(M theMaster);

	boolean isMaster(M theMaster, T theDateObject);

	boolean isSameMaster(M theMaster, M theOtherMaster);

	void createNewAfterClick(M theMaster, Date currentDate, Date endTime, DateEventListener<T> listener);

	void createNewAfterClick(M theMaster, Date currentDate, DateEventListener<T> listener);

	void editAfterClick(M theMaster, T data, DateEventListener<T> listener);

	EventPanel<T> createPanel(T newData);

	void getMaster(HorizontalViewPanelNoDays<T, M> caller, T theEvent);

	void getEventsForRange(HorizontalViewPanelNoDays<T, M> caller);

	HorizontalAddCallBackHandler<T, M> createAddHandler(HorizontalViewPanelNoDays<T, M> view, T theData);
	
	HorizontalUpdateCallBackHandler<T, M> createUpdateHandler(HorizontalViewPanelNoDays<T, M> view, T theData);
	
	HorizontalRemoveCallBackHandler<T, M> createRemoveHandler(HorizontalViewPanelNoDays<T, M> view, T theData);
	
	void addEvent(HorizontalAddCallBackHandler<T, M> callback);

	void updateEvent(HorizontalUpdateCallBackHandler<T, M> callback);

	void removeEvent(HorizontalRemoveCallBackHandler<T, M> callback);

}
