package eu.future.earth.gwt.client.date.horizontal;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import eu.future.earth.gwt.client.date.HorizontalDateCalculatorRenderer;

public class HorizontalTimeCalculator {

	private HorizontalDateCalculatorRenderer renderer;
	
	private Calendar helper = new GregorianCalendar();
	
	public HorizontalTimeCalculator(HorizontalDateCalculatorRenderer newRenderer) {
		super();
		renderer = newRenderer;
	}

	public int getTimePos(Date theDate) {
		helper.setTime(theDate);
		final int hours = helper.get(Calendar.HOUR_OF_DAY) - renderer.getStartHour();
		final int minutes = helper.get(Calendar.MINUTE);
		return calculateXForHoursMinutes(hours, minutes);
	}

	public int getTimePos(int hourToCalc, int minutes) {
		final int hours = hourToCalc - renderer.getStartHour();
		return calculateXForHoursMinutes(hours, minutes);
	}
	
	public int calculateXForHoursMinutes(int hours, int minutes) {
		return (int) Math.round((hours + (minutes / 60.0)) * renderer.getIntervalsPerHour() * renderer.getIntervalWidth());
	}

	public int calculateIntervalSnapForX(int x) {
		return (int) Math.round(((double) x) / renderer.getIntervalWidth());
	}
	
}
