package eu.future.earth.gwt.client.date.horizontal;

import java.util.Date;
import java.util.List;

public class HorizontalViewPanel<T, M> extends HorizontalViewPanelNoDays<T, M> {

	public HorizontalViewPanel(HorizontalDateRenderer<T, M> newRenderer, int newLabelWitd) {
		super(newRenderer, newLabelWitd);
	}

	private Date current = new Date();

	public Date getCurrent() {
		return current;
	}

	@Override
	public HorizontalItemRow<T, M> addRow(M newMaster) {
		HorizontalItemRow<T, M> newRow = super.addRow(newMaster);
		if (newRow != null) {
			newRow.setDay(current);
		}
		return newRow;
	}

	public void setDate(Date activeday) {
		current = activeday;
		List<HorizontalItemRow<T, M>> rowItems = getDayList();
		if (rowItems != null) {
			for (HorizontalItemRow<T, M> result : rowItems) {
				result.clearEvents();
				result.setDay(current);
			}
		}
	}

}
