/*
 * Copyright 2007 Future Earth, info@future-earth.eu
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package eu.future.earth.gwt.client.date.list;

import org.cobogw.gwt.user.client.CSS;

import com.google.gwt.user.client.ui.SimplePanel;
import com.google.gwt.user.client.ui.Widget;

import eu.future.earth.gwt.client.date.EventPanel;
import eu.future.earth.gwt.client.date.TimeEventRenderer;

public abstract class AbstractListField<T> extends EventPanel<T> {

	private SimplePanel whole = new SimplePanel();

	public void setWidth(int width) {
		if (width > 1) {
			super.setWidth(width + "px");
		}
	}

	public AbstractListField(TimeEventRenderer<T> newRenderer, T data) {
		super(newRenderer, data);
		super.setWidget(whole);
		whole.setWidth("100%");
		super.setWidth("100%");
	}

	public int getContentHeight() {
		return contentHeight;
	}

	private int contentHeight = 15;

	public void setContentHeight(int newContentHeight) {
		if (newContentHeight > 1) {
			this.contentHeight = newContentHeight;
			whole.setHeight(newContentHeight + "px");
		}
	}

	protected void setBody(Widget newBody) {
		if (whole.getWidget() == null) {
			if (newBody != null) {
				whole.setWidget(newBody);
				CSS.setProperty(newBody, CSS.A.OVERFLOW, CSS.V.OVERFLOW.HIDDEN);
				if (getEventStyleName() != null) {
					newBody.addStyleName(getEventStyleName());
				}
			}
		}
	}

	public void setEventStyleName(String eventStyleName) {
		super.setEventStyleName(eventStyleName);
	}

	public Widget getDraggableItem() {
		return null;
	}

	public Widget getPanel() {
		return whole;
	}

}
