package eu.future.earth.gwt.client.date.picker;

import java.util.Date;

import com.google.gwt.event.shared.HandlerRegistration;
import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.ui.DecoratedPopupPanel;
import com.google.gwt.user.client.ui.Widget;

import eu.future.earth.gwt.client.FtrGwtDatePickerCss;
import eu.future.earth.gwt.client.date.picker.DateSelectEvent.DateSelectEventActions;

public class DatePickerDialog extends DecoratedPopupPanel implements DateSelectListener, HasDateSelectHandlers {

	private DatePickerMonthNavigator whole = null;

	public DatePickerDialog(DatePickerRenderer renderer) {
		super(true);
		super.addStyleName(FtrGwtDatePickerCss.DIALOG);
		whole = new DatePickerMonthNavigator(renderer);
		setWidget(whole);
		whole.setWidth("250px");
		whole.addDateSelectEventHandler(this);
	}


	public void addWidgetToPicker(Widget newWidget) {
		whole.addWidgetToPicker(newWidget);
	};
	
	public void show(Widget below) {
		if (below == null) {
			super.show();
			super.center();
		} else {
			super.show();
			super.showRelativeTo(below);
//			super.setPopupPosition(below.getAbsoluteLeft(), below.getAbsoluteTop() + below.getOffsetHeight() + 10);
//			DOM.scrollIntoView(super.getElement());
		}
	}

	public void setSelectedDate(Date newDate) {
		whole.setSelectedDate(newDate);
	}

	public HandlerRegistration addDateSelectEventHandler(DateSelectListener handler) {
		return addHandler(handler, DateSelectEvent.getType());
	}

	public void handleDateSelectEvent(DateSelectEvent newEvent) {
		if (newEvent.getCommand() == DateSelectEventActions.SELECT_DAY) {
			DateSelectEvent.fire(this, newEvent);
			this.hide();
		}
		if (newEvent.getCommand() == DateSelectEventActions.SELECT_NEW_MONTH) {
			DateSelectEvent.fire(this, newEvent);
			this.hide();
		}
	}

}
